<?php

namespace Shop\Infrastructure\Models\Currency\Base;

use \Exception;
use \PDO;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\LogicException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;
use Shop\Infrastructure\Models\Currency\Currency as ChildCurrency;
use Shop\Infrastructure\Models\Currency\CurrencyQuery as ChildCurrencyQuery;
use Shop\Infrastructure\Models\Currency\ShopCurrenciesArchive as ChildShopCurrenciesArchive;
use Shop\Infrastructure\Models\Currency\ShopCurrenciesArchiveQuery as ChildShopCurrenciesArchiveQuery;
use Shop\Infrastructure\Models\Currency\Map\CurrencyTableMap;
use Shop\Infrastructure\Models\OrderItem\OrderItem;
use Shop\Infrastructure\Models\OrderItem\OrderItemQuery;
use Shop\Infrastructure\Models\OrderItem\Base\OrderItem as BaseOrderItem;
use Shop\Infrastructure\Models\OrderItem\Map\OrderItemTableMap;
use Shop\Infrastructure\Models\PricelistSheet\PricelistSheet;
use Shop\Infrastructure\Models\PricelistSheet\PricelistSheetQuery;
use Shop\Infrastructure\Models\PricelistSheet\Base\PricelistSheet as BasePricelistSheet;
use Shop\Infrastructure\Models\PricelistSheet\Map\PricelistSheetTableMap;
use Shop\Infrastructure\Models\Provider\Provider;
use Shop\Infrastructure\Models\Provider\ProviderQuery;
use Shop\Infrastructure\Models\Provider\Base\Provider as BaseProvider;
use Shop\Infrastructure\Models\Provider\Map\ProviderTableMap;

/**
 * Base class that represents a row from the 'shop_currencies' table.
 *
 *
 *
 * @package    propel.generator.Shop.Infrastructure.Models.Currency.Base
 */
abstract class Currency implements ActiveRecordInterface
{
    /**
     * TableMap class name
     *
     * @var string
     */
    public const TABLE_MAP = '\\Shop\\Infrastructure\\Models\\Currency\\Map\\CurrencyTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var bool
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var bool
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = [];

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = [];

    /**
     * The value for the id field.
     *
     * @var        int
     */
    protected $id;

    /**
     * The value for the name field.
     *
     * @var        string|null
     */
    protected $name;

    /**
     * The value for the native field.
     *
     * Note: this column has a database default value of: 'Y'
     * @var        string|null
     */
    protected $native;

    /**
     * The value for the position field.
     *
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $position;

    /**
     * The value for the html_sign field.
     *
     * @var        string|null
     */
    protected $html_sign;

    /**
     * The value for the round_price field.
     *
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $round_price;

    /**
     * The value for the displayed field.
     *
     * Note: this column has a database default value of: 'Y'
     * @var        string|null
     */
    protected $displayed;

    /**
     * The value for the iso field.
     *
     * @var        string|null
     */
    protected $iso;

    /**
     * The value for the rbk_sync field.
     *
     * Note: this column has a database default value of: 'N'
     * @var        string|null
     */
    protected $rbk_sync;

    /**
     * The value for the round_mode field.
     *
     * Note: this column has a database default value of: 'ceil'
     * @var        string|null
     */
    protected $round_mode;

    /**
     * @var        ObjectCollection|OrderItem[] Collection to store aggregation of OrderItem objects.
     * @phpstan-var ObjectCollection&\Traversable<OrderItem> Collection to store aggregation of OrderItem objects.
     */
    protected $collOrderItems;
    protected $collOrderItemsPartial;

    /**
     * @var        ObjectCollection|PricelistSheet[] Collection to store aggregation of PricelistSheet objects.
     * @phpstan-var ObjectCollection&\Traversable<PricelistSheet> Collection to store aggregation of PricelistSheet objects.
     */
    protected $collPricelistSheets;
    protected $collPricelistSheetsPartial;

    /**
     * @var        ObjectCollection|Provider[] Collection to store aggregation of Provider objects.
     * @phpstan-var ObjectCollection&\Traversable<Provider> Collection to store aggregation of Provider objects.
     */
    protected $collProviders;
    protected $collProvidersPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var bool
     */
    protected $alreadyInSave = false;

    // archivable behavior
    protected $archiveOnDelete = true;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|OrderItem[]
     * @phpstan-var ObjectCollection&\Traversable<OrderItem>
     */
    protected $orderItemsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|PricelistSheet[]
     * @phpstan-var ObjectCollection&\Traversable<PricelistSheet>
     */
    protected $pricelistSheetsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|Provider[]
     * @phpstan-var ObjectCollection&\Traversable<Provider>
     */
    protected $providersScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues(): void
    {
        $this->native = 'Y';
        $this->position = 0;
        $this->round_price = 0;
        $this->displayed = 'Y';
        $this->rbk_sync = 'N';
        $this->round_mode = 'ceil';
    }

    /**
     * Initializes internal state of Shop\Infrastructure\Models\Currency\Base\Currency object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return bool True if the object has been modified.
     */
    public function isModified(): bool
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param string $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return bool True if $col has been modified.
     */
    public function isColumnModified(string $col): bool
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns(): array
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return bool True, if the object has never been persisted.
     */
    public function isNew(): bool
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param bool $b the state of the object.
     */
    public function setNew(bool $b): void
    {
        $this->new = $b;
    }

    /**
     * Whether this object has been deleted.
     * @return bool The deleted state of this object.
     */
    public function isDeleted(): bool
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param bool $b The deleted state of this object.
     * @return void
     */
    public function setDeleted(bool $b): void
    {
        $this->deleted = $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified(?string $col = null): void
    {
        if (null !== $col) {
            unset($this->modifiedColumns[$col]);
        } else {
            $this->modifiedColumns = [];
        }
    }

    /**
     * Compares this with another <code>Currency</code> instance.  If
     * <code>obj</code> is an instance of <code>Currency</code>, delegates to
     * <code>equals(Currency)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param mixed $obj The object to compare to.
     * @return bool Whether equal to the object specified.
     */
    public function equals($obj): bool
    {
        if (!$obj instanceof static) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey() || null === $obj->getPrimaryKey()) {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns(): array
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @return bool
     */
    public function hasVirtualColumn(string $name): bool
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @return mixed
     *
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getVirtualColumn(string $name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of nonexistent virtual column `%s`.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @param mixed $value The value to give to the virtual column
     *
     * @return $this The current object, for fluid interface
     */
    public function setVirtualColumn(string $name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param string $msg
     * @param int $priority One of the Propel::LOG_* logging levels
     * @return void
     */
    protected function log(string $msg, int $priority = Propel::LOG_INFO): void
    {
        Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param \Propel\Runtime\Parser\AbstractParser|string $parser An AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param bool $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @param string $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME, TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. Defaults to TableMap::TYPE_PHPNAME.
     * @return string The exported data
     */
    public function exportTo($parser, bool $includeLazyLoadColumns = true, string $keyType = TableMap::TYPE_PHPNAME): string
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray($keyType, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     *
     * @return array<string>
     */
    public function __sleep(): array
    {
        $this->clearAllReferences();

        $cls = new \ReflectionClass($this);
        $propertyNames = [];
        $serializableProperties = array_diff($cls->getProperties(), $cls->getProperties(\ReflectionProperty::IS_STATIC));

        foreach($serializableProperties as $property) {
            $propertyNames[] = $property->getName();
        }

        return $propertyNames;
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Get the [name] column value.
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Get the [native] column value.
     *
     * @return string|null
     */
    public function getNative()
    {
        return $this->native;
    }

    /**
     * Get the [position] column value.
     *
     * @return int
     */
    public function getPosition()
    {
        return $this->position;
    }

    /**
     * Get the [html_sign] column value.
     *
     * @return string|null
     */
    public function getHtmlSign()
    {
        return $this->html_sign;
    }

    /**
     * Get the [round_price] column value.
     *
     * @return int
     */
    public function getRoundPrice()
    {
        return $this->round_price;
    }

    /**
     * Get the [displayed] column value.
     *
     * @return string|null
     */
    public function getDisplayed()
    {
        return $this->displayed;
    }

    /**
     * Get the [iso] column value.
     *
     * @return string|null
     */
    public function getIso()
    {
        return $this->iso;
    }

    /**
     * Get the [rbk_sync] column value.
     *
     * @return string|null
     */
    public function getRbkSync()
    {
        return $this->rbk_sync;
    }

    /**
     * Get the [round_mode] column value.
     *
     * @return string|null
     */
    public function getRoundMode()
    {
        return $this->round_mode;
    }

    /**
     * Set the value of [id] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_ID] = true;
        }

        return $this;
    }

    /**
     * Set the value of [name] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_NAME] = true;
        }

        return $this;
    }

    /**
     * Set the value of [native] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setNative($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->native !== $v) {
            $this->native = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_NATIVE] = true;
        }

        return $this;
    }

    /**
     * Set the value of [position] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setPosition($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->position !== $v) {
            $this->position = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_POSITION] = true;
        }

        return $this;
    }

    /**
     * Set the value of [html_sign] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setHtmlSign($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->html_sign !== $v) {
            $this->html_sign = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_HTML_SIGN] = true;
        }

        return $this;
    }

    /**
     * Set the value of [round_price] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setRoundPrice($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->round_price !== $v) {
            $this->round_price = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_ROUND_PRICE] = true;
        }

        return $this;
    }

    /**
     * Set the value of [displayed] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setDisplayed($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->displayed !== $v) {
            $this->displayed = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_DISPLAYED] = true;
        }

        return $this;
    }

    /**
     * Set the value of [iso] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setIso($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->iso !== $v) {
            $this->iso = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_ISO] = true;
        }

        return $this;
    }

    /**
     * Set the value of [rbk_sync] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setRbkSync($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->rbk_sync !== $v) {
            $this->rbk_sync = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_RBK_SYNC] = true;
        }

        return $this;
    }

    /**
     * Set the value of [round_mode] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setRoundMode($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->round_mode !== $v) {
            $this->round_mode = $v;
            $this->modifiedColumns[CurrencyTableMap::COL_ROUND_MODE] = true;
        }

        return $this;
    }

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return bool Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues(): bool
    {
            if ($this->native !== 'Y') {
                return false;
            }

            if ($this->position !== 0) {
                return false;
            }

            if ($this->round_price !== 0) {
                return false;
            }

            if ($this->displayed !== 'Y') {
                return false;
            }

            if ($this->rbk_sync !== 'N') {
                return false;
            }

            if ($this->round_mode !== 'ceil') {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    }

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by DataFetcher->fetch().
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param bool $rehydrate Whether this object is being re-hydrated from the database.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int next starting column
     * @throws \Propel\Runtime\Exception\PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(array $row, int $startcol = 0, bool $rehydrate = false, string $indexType = TableMap::TYPE_NUM): int
    {
        try {

            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : CurrencyTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : CurrencyTableMap::translateFieldName('Name', TableMap::TYPE_PHPNAME, $indexType)];
            $this->name = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : CurrencyTableMap::translateFieldName('Native', TableMap::TYPE_PHPNAME, $indexType)];
            $this->native = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : CurrencyTableMap::translateFieldName('Position', TableMap::TYPE_PHPNAME, $indexType)];
            $this->position = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : CurrencyTableMap::translateFieldName('HtmlSign', TableMap::TYPE_PHPNAME, $indexType)];
            $this->html_sign = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 5 + $startcol : CurrencyTableMap::translateFieldName('RoundPrice', TableMap::TYPE_PHPNAME, $indexType)];
            $this->round_price = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 6 + $startcol : CurrencyTableMap::translateFieldName('Displayed', TableMap::TYPE_PHPNAME, $indexType)];
            $this->displayed = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 7 + $startcol : CurrencyTableMap::translateFieldName('Iso', TableMap::TYPE_PHPNAME, $indexType)];
            $this->iso = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 8 + $startcol : CurrencyTableMap::translateFieldName('RbkSync', TableMap::TYPE_PHPNAME, $indexType)];
            $this->rbk_sync = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 9 + $startcol : CurrencyTableMap::translateFieldName('RoundMode', TableMap::TYPE_PHPNAME, $indexType)];
            $this->round_mode = (null !== $col) ? (string) $col : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 10; // 10 = CurrencyTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException(sprintf('Error populating %s object', '\\Shop\\Infrastructure\\Models\\Currency\\Currency'), 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws \Propel\Runtime\Exception\PropelException
     * @return void
     */
    public function ensureConsistency(): void
    {
    }

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param bool $deep (optional) Whether to also de-associated any related objects.
     * @param ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws \Propel\Runtime\Exception\PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload(bool $deep = false, ?ConnectionInterface $con = null): void
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(CurrencyTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildCurrencyQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->collOrderItems = null;

            $this->collPricelistSheets = null;

            $this->collProviders = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param ConnectionInterface $con
     * @return void
     * @throws \Propel\Runtime\Exception\PropelException
     * @see Currency::setDeleted()
     * @see Currency::isDeleted()
     */
    public function delete(?ConnectionInterface $con = null): void
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(CurrencyTableMap::DATABASE_NAME);
        }

        $con->transaction(function () use ($con) {
            $deleteQuery = ChildCurrencyQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            // archivable behavior
            if ($ret) {
                if ($this->archiveOnDelete) {
                    // do nothing yet. The object will be archived later when calling ChildCurrencyQuery::delete().
                } else {
                    $deleteQuery->setArchiveOnDelete(false);
                    $this->archiveOnDelete = true;
                }
            }

            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $this->setDeleted(true);
            }
        });
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param ConnectionInterface $con
     * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws \Propel\Runtime\Exception\PropelException
     * @see doSave()
     */
    public function save(?ConnectionInterface $con = null): int
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($this->alreadyInSave) {
            return 0;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(CurrencyTableMap::DATABASE_NAME);
        }

        return $con->transaction(function () use ($con) {
            $ret = $this->preSave($con);
            $isInsert = $this->isNew();
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                CurrencyTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }

            return $affectedRows;
        });
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param ConnectionInterface $con
     * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws \Propel\Runtime\Exception\PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con): int
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                    $affectedRows += 1;
                } else {
                    $affectedRows += $this->doUpdate($con);
                }
                $this->resetModified();
            }

            if ($this->orderItemsScheduledForDeletion !== null) {
                if (!$this->orderItemsScheduledForDeletion->isEmpty()) {
                    \Shop\Infrastructure\Models\OrderItem\OrderItemQuery::create()
                        ->filterByPrimaryKeys($this->orderItemsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->orderItemsScheduledForDeletion = null;
                }
            }

            if ($this->collOrderItems !== null) {
                foreach ($this->collOrderItems as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->pricelistSheetsScheduledForDeletion !== null) {
                if (!$this->pricelistSheetsScheduledForDeletion->isEmpty()) {
                    \Shop\Infrastructure\Models\PricelistSheet\PricelistSheetQuery::create()
                        ->filterByPrimaryKeys($this->pricelistSheetsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->pricelistSheetsScheduledForDeletion = null;
                }
            }

            if ($this->collPricelistSheets !== null) {
                foreach ($this->collPricelistSheets as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->providersScheduledForDeletion !== null) {
                if (!$this->providersScheduledForDeletion->isEmpty()) {
                    \Shop\Infrastructure\Models\Provider\ProviderQuery::create()
                        ->filterByPrimaryKeys($this->providersScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->providersScheduledForDeletion = null;
                }
            }

            if ($this->collProviders !== null) {
                foreach ($this->collProviders as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    }

    /**
     * Insert the row in the database.
     *
     * @param ConnectionInterface $con
     *
     * @throws \Propel\Runtime\Exception\PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con): void
    {
        $modifiedColumns = [];
        $index = 0;

        $this->modifiedColumns[CurrencyTableMap::COL_ID] = true;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . CurrencyTableMap::COL_ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(CurrencyTableMap::COL_ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_NATIVE)) {
            $modifiedColumns[':p' . $index++]  = '`native`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_POSITION)) {
            $modifiedColumns[':p' . $index++]  = '`position`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_HTML_SIGN)) {
            $modifiedColumns[':p' . $index++]  = '`html_sign`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ROUND_PRICE)) {
            $modifiedColumns[':p' . $index++]  = '`round_price`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_DISPLAYED)) {
            $modifiedColumns[':p' . $index++]  = '`displayed`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ISO)) {
            $modifiedColumns[':p' . $index++]  = '`iso`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_RBK_SYNC)) {
            $modifiedColumns[':p' . $index++]  = '`rbk_sync`';
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ROUND_MODE)) {
            $modifiedColumns[':p' . $index++]  = '`round_mode`';
        }

        $sql = sprintf(
            'INSERT INTO `shop_currencies` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`native`':
                        $stmt->bindValue($identifier, $this->native, PDO::PARAM_STR);
                        break;
                    case '`position`':
                        $stmt->bindValue($identifier, $this->position, PDO::PARAM_INT);
                        break;
                    case '`html_sign`':
                        $stmt->bindValue($identifier, $this->html_sign, PDO::PARAM_STR);
                        break;
                    case '`round_price`':
                        $stmt->bindValue($identifier, $this->round_price, PDO::PARAM_INT);
                        break;
                    case '`displayed`':
                        $stmt->bindValue($identifier, $this->displayed, PDO::PARAM_STR);
                        break;
                    case '`iso`':
                        $stmt->bindValue($identifier, $this->iso, PDO::PARAM_STR);
                        break;
                    case '`rbk_sync`':
                        $stmt->bindValue($identifier, $this->rbk_sync, PDO::PARAM_STR);
                        break;
                    case '`round_mode`':
                        $stmt->bindValue($identifier, $this->round_mode, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', 0, $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param ConnectionInterface $con
     *
     * @return int Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con): int
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName(string $name, string $type = TableMap::TYPE_PHPNAME)
    {
        $pos = CurrencyTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos Position in XML schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition(int $pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();

            case 1:
                return $this->getName();

            case 2:
                return $this->getNative();

            case 3:
                return $this->getPosition();

            case 4:
                return $this->getHtmlSign();

            case 5:
                return $this->getRoundPrice();

            case 6:
                return $this->getDisplayed();

            case 7:
                return $this->getIso();

            case 8:
                return $this->getRbkSync();

            case 9:
                return $this->getRoundMode();

            default:
                return null;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param string $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param bool $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param bool $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array An associative array containing the field names (as keys) and field values
     */
    public function toArray(string $keyType = TableMap::TYPE_PHPNAME, bool $includeLazyLoadColumns = true, array $alreadyDumpedObjects = [], bool $includeForeignObjects = false): array
    {
        if (isset($alreadyDumpedObjects['Currency'][$this->hashCode()])) {
            return ['*RECURSION*'];
        }
        $alreadyDumpedObjects['Currency'][$this->hashCode()] = true;
        $keys = CurrencyTableMap::getFieldNames($keyType);
        $result = [
            $keys[0] => $this->getId(),
            $keys[1] => $this->getName(),
            $keys[2] => $this->getNative(),
            $keys[3] => $this->getPosition(),
            $keys[4] => $this->getHtmlSign(),
            $keys[5] => $this->getRoundPrice(),
            $keys[6] => $this->getDisplayed(),
            $keys[7] => $this->getIso(),
            $keys[8] => $this->getRbkSync(),
            $keys[9] => $this->getRoundMode(),
        ];
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->collOrderItems) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'orderItems';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_order_itemss';
                        break;
                    default:
                        $key = 'OrderItems';
                }

                $result[$key] = $this->collOrderItems->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collPricelistSheets) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'pricelistSheets';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_pricelist_sheetss';
                        break;
                    default:
                        $key = 'PricelistSheets';
                }

                $result[$key] = $this->collPricelistSheets->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collProviders) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'providers';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'shop_providerss';
                        break;
                    default:
                        $key = 'Providers';
                }

                $result[$key] = $this->collProviders->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                Defaults to TableMap::TYPE_PHPNAME.
     * @return $this
     */
    public function setByName(string $name, $value, string $type = TableMap::TYPE_PHPNAME)
    {
        $pos = CurrencyTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        $this->setByPosition($pos, $value);

        return $this;
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return $this
     */
    public function setByPosition(int $pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setName($value);
                break;
            case 2:
                $this->setNative($value);
                break;
            case 3:
                $this->setPosition($value);
                break;
            case 4:
                $this->setHtmlSign($value);
                break;
            case 5:
                $this->setRoundPrice($value);
                break;
            case 6:
                $this->setDisplayed($value);
                break;
            case 7:
                $this->setIso($value);
                break;
            case 8:
                $this->setRbkSync($value);
                break;
            case 9:
                $this->setRoundMode($value);
                break;
        } // switch()

        return $this;
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param array $arr An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return $this
     */
    public function fromArray(array $arr, string $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = CurrencyTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setId($arr[$keys[0]]);
        }
        if (array_key_exists($keys[1], $arr)) {
            $this->setName($arr[$keys[1]]);
        }
        if (array_key_exists($keys[2], $arr)) {
            $this->setNative($arr[$keys[2]]);
        }
        if (array_key_exists($keys[3], $arr)) {
            $this->setPosition($arr[$keys[3]]);
        }
        if (array_key_exists($keys[4], $arr)) {
            $this->setHtmlSign($arr[$keys[4]]);
        }
        if (array_key_exists($keys[5], $arr)) {
            $this->setRoundPrice($arr[$keys[5]]);
        }
        if (array_key_exists($keys[6], $arr)) {
            $this->setDisplayed($arr[$keys[6]]);
        }
        if (array_key_exists($keys[7], $arr)) {
            $this->setIso($arr[$keys[7]]);
        }
        if (array_key_exists($keys[8], $arr)) {
            $this->setRbkSync($arr[$keys[8]]);
        }
        if (array_key_exists($keys[9], $arr)) {
            $this->setRoundMode($arr[$keys[9]]);
        }

        return $this;
    }

     /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     * @param string $keyType The type of keys the array uses.
     *
     * @return $this The current object, for fluid interface
     */
    public function importFrom($parser, string $data, string $keyType = TableMap::TYPE_PHPNAME)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), $keyType);

        return $this;
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return \Propel\Runtime\ActiveQuery\Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria(): Criteria
    {
        $criteria = new Criteria(CurrencyTableMap::DATABASE_NAME);

        if ($this->isColumnModified(CurrencyTableMap::COL_ID)) {
            $criteria->add(CurrencyTableMap::COL_ID, $this->id);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_NAME)) {
            $criteria->add(CurrencyTableMap::COL_NAME, $this->name);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_NATIVE)) {
            $criteria->add(CurrencyTableMap::COL_NATIVE, $this->native);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_POSITION)) {
            $criteria->add(CurrencyTableMap::COL_POSITION, $this->position);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_HTML_SIGN)) {
            $criteria->add(CurrencyTableMap::COL_HTML_SIGN, $this->html_sign);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ROUND_PRICE)) {
            $criteria->add(CurrencyTableMap::COL_ROUND_PRICE, $this->round_price);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_DISPLAYED)) {
            $criteria->add(CurrencyTableMap::COL_DISPLAYED, $this->displayed);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ISO)) {
            $criteria->add(CurrencyTableMap::COL_ISO, $this->iso);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_RBK_SYNC)) {
            $criteria->add(CurrencyTableMap::COL_RBK_SYNC, $this->rbk_sync);
        }
        if ($this->isColumnModified(CurrencyTableMap::COL_ROUND_MODE)) {
            $criteria->add(CurrencyTableMap::COL_ROUND_MODE, $this->round_mode);
        }

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether they have been modified.
     *
     * @throws LogicException if no primary key is defined
     *
     * @return \Propel\Runtime\ActiveQuery\Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria(): Criteria
    {
        $criteria = ChildCurrencyQuery::create();
        $criteria->add(CurrencyTableMap::COL_ID, $this->id);

        return $criteria;
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int|string Hashcode
     */
    public function hashCode()
    {
        $validPk = null !== $this->getId();

        $validPrimaryKeyFKs = 0;
        $primaryKeyFKs = [];

        if ($validPk) {
            return crc32(json_encode($this->getPrimaryKey(), JSON_UNESCAPED_UNICODE));
        } elseif ($validPrimaryKeyFKs) {
            return crc32(json_encode($primaryKeyFKs, JSON_UNESCAPED_UNICODE));
        }

        return spl_object_hash($this);
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param int|null $key Primary key.
     * @return void
     */
    public function setPrimaryKey(?int $key = null): void
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     *
     * @return bool
     */
    public function isPrimaryKeyNull(): bool
    {
        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of \Shop\Infrastructure\Models\Currency\Currency (or compatible) type.
     * @param bool $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param bool $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws \Propel\Runtime\Exception\PropelException
     * @return void
     */
    public function copyInto(object $copyObj, bool $deepCopy = false, bool $makeNew = true): void
    {
        $copyObj->setName($this->getName());
        $copyObj->setNative($this->getNative());
        $copyObj->setPosition($this->getPosition());
        $copyObj->setHtmlSign($this->getHtmlSign());
        $copyObj->setRoundPrice($this->getRoundPrice());
        $copyObj->setDisplayed($this->getDisplayed());
        $copyObj->setIso($this->getIso());
        $copyObj->setRbkSync($this->getRbkSync());
        $copyObj->setRoundMode($this->getRoundMode());

        if ($deepCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach ($this->getOrderItems() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addOrderItem($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getPricelistSheets() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addPricelistSheet($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getProviders() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addProvider($relObj->copy($deepCopy));
                }
            }

        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param bool $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return \Shop\Infrastructure\Models\Currency\Currency Clone of current object.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function copy(bool $deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName): void
    {
        if ('OrderItem' === $relationName) {
            $this->initOrderItems();
            return;
        }
        if ('PricelistSheet' === $relationName) {
            $this->initPricelistSheets();
            return;
        }
        if ('Provider' === $relationName) {
            $this->initProviders();
            return;
        }
    }

    /**
     * Clears out the collOrderItems collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addOrderItems()
     */
    public function clearOrderItems()
    {
        $this->collOrderItems = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collOrderItems collection loaded partially.
     *
     * @return void
     */
    public function resetPartialOrderItems($v = true): void
    {
        $this->collOrderItemsPartial = $v;
    }

    /**
     * Initializes the collOrderItems collection.
     *
     * By default this just sets the collOrderItems collection to an empty array (like clearcollOrderItems());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initOrderItems(bool $overrideExisting = true): void
    {
        if (null !== $this->collOrderItems && !$overrideExisting) {
            return;
        }

        $collectionClassName = OrderItemTableMap::getTableMap()->getCollectionClassName();

        $this->collOrderItems = new $collectionClassName;
        $this->collOrderItems->setModel('\Shop\Infrastructure\Models\OrderItem\OrderItem');
    }

    /**
     * Gets an array of OrderItem objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildCurrency is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|OrderItem[] List of OrderItem objects
     * @phpstan-return ObjectCollection&\Traversable<OrderItem> List of OrderItem objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getOrderItems(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collOrderItemsPartial && !$this->isNew();
        if (null === $this->collOrderItems || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collOrderItems) {
                    $this->initOrderItems();
                } else {
                    $collectionClassName = OrderItemTableMap::getTableMap()->getCollectionClassName();

                    $collOrderItems = new $collectionClassName;
                    $collOrderItems->setModel('\Shop\Infrastructure\Models\OrderItem\OrderItem');

                    return $collOrderItems;
                }
            } else {
                $collOrderItems = OrderItemQuery::create(null, $criteria)
                    ->filterByCurrency($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collOrderItemsPartial && count($collOrderItems)) {
                        $this->initOrderItems(false);

                        foreach ($collOrderItems as $obj) {
                            if (false == $this->collOrderItems->contains($obj)) {
                                $this->collOrderItems->append($obj);
                            }
                        }

                        $this->collOrderItemsPartial = true;
                    }

                    return $collOrderItems;
                }

                if ($partial && $this->collOrderItems) {
                    foreach ($this->collOrderItems as $obj) {
                        if ($obj->isNew()) {
                            $collOrderItems[] = $obj;
                        }
                    }
                }

                $this->collOrderItems = $collOrderItems;
                $this->collOrderItemsPartial = false;
            }
        }

        return $this->collOrderItems;
    }

    /**
     * Sets a collection of OrderItem objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $orderItems A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setOrderItems(Collection $orderItems, ?ConnectionInterface $con = null)
    {
        /** @var OrderItem[] $orderItemsToDelete */
        $orderItemsToDelete = $this->getOrderItems(new Criteria(), $con)->diff($orderItems);


        $this->orderItemsScheduledForDeletion = $orderItemsToDelete;

        foreach ($orderItemsToDelete as $orderItemRemoved) {
            $orderItemRemoved->setCurrency(null);
        }

        $this->collOrderItems = null;
        foreach ($orderItems as $orderItem) {
            $this->addOrderItem($orderItem);
        }

        $this->collOrderItems = $orderItems;
        $this->collOrderItemsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseOrderItem objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BaseOrderItem objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countOrderItems(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collOrderItemsPartial && !$this->isNew();
        if (null === $this->collOrderItems || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collOrderItems) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getOrderItems());
            }

            $query = OrderItemQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByCurrency($this)
                ->count($con);
        }

        return count($this->collOrderItems);
    }

    /**
     * Method called to associate a OrderItem object to this object
     * through the OrderItem foreign key attribute.
     *
     * @param OrderItem $l OrderItem
     * @return $this The current object (for fluent API support)
     */
    public function addOrderItem(OrderItem $l)
    {
        if ($this->collOrderItems === null) {
            $this->initOrderItems();
            $this->collOrderItemsPartial = true;
        }

        if (!$this->collOrderItems->contains($l)) {
            $this->doAddOrderItem($l);

            if ($this->orderItemsScheduledForDeletion and $this->orderItemsScheduledForDeletion->contains($l)) {
                $this->orderItemsScheduledForDeletion->remove($this->orderItemsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param OrderItem $orderItem The OrderItem object to add.
     */
    protected function doAddOrderItem(OrderItem $orderItem): void
    {
        $this->collOrderItems[]= $orderItem;
        $orderItem->setCurrency($this);
    }

    /**
     * @param OrderItem $orderItem The OrderItem object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removeOrderItem(OrderItem $orderItem)
    {
        if ($this->getOrderItems()->contains($orderItem)) {
            $pos = $this->collOrderItems->search($orderItem);
            $this->collOrderItems->remove($pos);
            if (null === $this->orderItemsScheduledForDeletion) {
                $this->orderItemsScheduledForDeletion = clone $this->collOrderItems;
                $this->orderItemsScheduledForDeletion->clear();
            }
            $this->orderItemsScheduledForDeletion[]= clone $orderItem;
            $orderItem->setCurrency(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Currency is new, it will return
     * an empty collection; or if this Currency has previously
     * been saved, it will retrieve related OrderItems from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Currency.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|OrderItem[] List of OrderItem objects
     * @phpstan-return ObjectCollection&\Traversable<OrderItem}> List of OrderItem objects
     */
    public function getOrderItemsJoinOrder(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = OrderItemQuery::create(null, $criteria);
        $query->joinWith('Order', $joinBehavior);

        return $this->getOrderItems($query, $con);
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Currency is new, it will return
     * an empty collection; or if this Currency has previously
     * been saved, it will retrieve related OrderItems from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Currency.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|OrderItem[] List of OrderItem objects
     * @phpstan-return ObjectCollection&\Traversable<OrderItem}> List of OrderItem objects
     */
    public function getOrderItemsJoinState(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = OrderItemQuery::create(null, $criteria);
        $query->joinWith('State', $joinBehavior);

        return $this->getOrderItems($query, $con);
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Currency is new, it will return
     * an empty collection; or if this Currency has previously
     * been saved, it will retrieve related OrderItems from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Currency.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|OrderItem[] List of OrderItem objects
     * @phpstan-return ObjectCollection&\Traversable<OrderItem}> List of OrderItem objects
     */
    public function getOrderItemsJoinProvider(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = OrderItemQuery::create(null, $criteria);
        $query->joinWith('Provider', $joinBehavior);

        return $this->getOrderItems($query, $con);
    }

    /**
     * Clears out the collPricelistSheets collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addPricelistSheets()
     */
    public function clearPricelistSheets()
    {
        $this->collPricelistSheets = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collPricelistSheets collection loaded partially.
     *
     * @return void
     */
    public function resetPartialPricelistSheets($v = true): void
    {
        $this->collPricelistSheetsPartial = $v;
    }

    /**
     * Initializes the collPricelistSheets collection.
     *
     * By default this just sets the collPricelistSheets collection to an empty array (like clearcollPricelistSheets());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initPricelistSheets(bool $overrideExisting = true): void
    {
        if (null !== $this->collPricelistSheets && !$overrideExisting) {
            return;
        }

        $collectionClassName = PricelistSheetTableMap::getTableMap()->getCollectionClassName();

        $this->collPricelistSheets = new $collectionClassName;
        $this->collPricelistSheets->setModel('\Shop\Infrastructure\Models\PricelistSheet\PricelistSheet');
    }

    /**
     * Gets an array of PricelistSheet objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildCurrency is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|PricelistSheet[] List of PricelistSheet objects
     * @phpstan-return ObjectCollection&\Traversable<PricelistSheet> List of PricelistSheet objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getPricelistSheets(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collPricelistSheetsPartial && !$this->isNew();
        if (null === $this->collPricelistSheets || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collPricelistSheets) {
                    $this->initPricelistSheets();
                } else {
                    $collectionClassName = PricelistSheetTableMap::getTableMap()->getCollectionClassName();

                    $collPricelistSheets = new $collectionClassName;
                    $collPricelistSheets->setModel('\Shop\Infrastructure\Models\PricelistSheet\PricelistSheet');

                    return $collPricelistSheets;
                }
            } else {
                $collPricelistSheets = PricelistSheetQuery::create(null, $criteria)
                    ->filterByCurrency($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collPricelistSheetsPartial && count($collPricelistSheets)) {
                        $this->initPricelistSheets(false);

                        foreach ($collPricelistSheets as $obj) {
                            if (false == $this->collPricelistSheets->contains($obj)) {
                                $this->collPricelistSheets->append($obj);
                            }
                        }

                        $this->collPricelistSheetsPartial = true;
                    }

                    return $collPricelistSheets;
                }

                if ($partial && $this->collPricelistSheets) {
                    foreach ($this->collPricelistSheets as $obj) {
                        if ($obj->isNew()) {
                            $collPricelistSheets[] = $obj;
                        }
                    }
                }

                $this->collPricelistSheets = $collPricelistSheets;
                $this->collPricelistSheetsPartial = false;
            }
        }

        return $this->collPricelistSheets;
    }

    /**
     * Sets a collection of PricelistSheet objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $pricelistSheets A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setPricelistSheets(Collection $pricelistSheets, ?ConnectionInterface $con = null)
    {
        /** @var PricelistSheet[] $pricelistSheetsToDelete */
        $pricelistSheetsToDelete = $this->getPricelistSheets(new Criteria(), $con)->diff($pricelistSheets);


        $this->pricelistSheetsScheduledForDeletion = $pricelistSheetsToDelete;

        foreach ($pricelistSheetsToDelete as $pricelistSheetRemoved) {
            $pricelistSheetRemoved->setCurrency(null);
        }

        $this->collPricelistSheets = null;
        foreach ($pricelistSheets as $pricelistSheet) {
            $this->addPricelistSheet($pricelistSheet);
        }

        $this->collPricelistSheets = $pricelistSheets;
        $this->collPricelistSheetsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BasePricelistSheet objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BasePricelistSheet objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countPricelistSheets(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collPricelistSheetsPartial && !$this->isNew();
        if (null === $this->collPricelistSheets || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collPricelistSheets) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getPricelistSheets());
            }

            $query = PricelistSheetQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByCurrency($this)
                ->count($con);
        }

        return count($this->collPricelistSheets);
    }

    /**
     * Method called to associate a PricelistSheet object to this object
     * through the PricelistSheet foreign key attribute.
     *
     * @param PricelistSheet $l PricelistSheet
     * @return $this The current object (for fluent API support)
     */
    public function addPricelistSheet(PricelistSheet $l)
    {
        if ($this->collPricelistSheets === null) {
            $this->initPricelistSheets();
            $this->collPricelistSheetsPartial = true;
        }

        if (!$this->collPricelistSheets->contains($l)) {
            $this->doAddPricelistSheet($l);

            if ($this->pricelistSheetsScheduledForDeletion and $this->pricelistSheetsScheduledForDeletion->contains($l)) {
                $this->pricelistSheetsScheduledForDeletion->remove($this->pricelistSheetsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param PricelistSheet $pricelistSheet The PricelistSheet object to add.
     */
    protected function doAddPricelistSheet(PricelistSheet $pricelistSheet): void
    {
        $this->collPricelistSheets[]= $pricelistSheet;
        $pricelistSheet->setCurrency($this);
    }

    /**
     * @param PricelistSheet $pricelistSheet The PricelistSheet object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removePricelistSheet(PricelistSheet $pricelistSheet)
    {
        if ($this->getPricelistSheets()->contains($pricelistSheet)) {
            $pos = $this->collPricelistSheets->search($pricelistSheet);
            $this->collPricelistSheets->remove($pos);
            if (null === $this->pricelistSheetsScheduledForDeletion) {
                $this->pricelistSheetsScheduledForDeletion = clone $this->collPricelistSheets;
                $this->pricelistSheetsScheduledForDeletion->clear();
            }
            $this->pricelistSheetsScheduledForDeletion[]= clone $pricelistSheet;
            $pricelistSheet->setCurrency(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Currency is new, it will return
     * an empty collection; or if this Currency has previously
     * been saved, it will retrieve related PricelistSheets from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Currency.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|PricelistSheet[] List of PricelistSheet objects
     * @phpstan-return ObjectCollection&\Traversable<PricelistSheet}> List of PricelistSheet objects
     */
    public function getPricelistSheetsJoinPricelistFile(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = PricelistSheetQuery::create(null, $criteria);
        $query->joinWith('PricelistFile', $joinBehavior);

        return $this->getPricelistSheets($query, $con);
    }

    /**
     * Clears out the collProviders collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addProviders()
     */
    public function clearProviders()
    {
        $this->collProviders = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collProviders collection loaded partially.
     *
     * @return void
     */
    public function resetPartialProviders($v = true): void
    {
        $this->collProvidersPartial = $v;
    }

    /**
     * Initializes the collProviders collection.
     *
     * By default this just sets the collProviders collection to an empty array (like clearcollProviders());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initProviders(bool $overrideExisting = true): void
    {
        if (null !== $this->collProviders && !$overrideExisting) {
            return;
        }

        $collectionClassName = ProviderTableMap::getTableMap()->getCollectionClassName();

        $this->collProviders = new $collectionClassName;
        $this->collProviders->setModel('\Shop\Infrastructure\Models\Provider\Provider');
    }

    /**
     * Gets an array of Provider objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildCurrency is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|Provider[] List of Provider objects
     * @phpstan-return ObjectCollection&\Traversable<Provider> List of Provider objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getProviders(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collProvidersPartial && !$this->isNew();
        if (null === $this->collProviders || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collProviders) {
                    $this->initProviders();
                } else {
                    $collectionClassName = ProviderTableMap::getTableMap()->getCollectionClassName();

                    $collProviders = new $collectionClassName;
                    $collProviders->setModel('\Shop\Infrastructure\Models\Provider\Provider');

                    return $collProviders;
                }
            } else {
                $collProviders = ProviderQuery::create(null, $criteria)
                    ->filterByCurrency($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collProvidersPartial && count($collProviders)) {
                        $this->initProviders(false);

                        foreach ($collProviders as $obj) {
                            if (false == $this->collProviders->contains($obj)) {
                                $this->collProviders->append($obj);
                            }
                        }

                        $this->collProvidersPartial = true;
                    }

                    return $collProviders;
                }

                if ($partial && $this->collProviders) {
                    foreach ($this->collProviders as $obj) {
                        if ($obj->isNew()) {
                            $collProviders[] = $obj;
                        }
                    }
                }

                $this->collProviders = $collProviders;
                $this->collProvidersPartial = false;
            }
        }

        return $this->collProviders;
    }

    /**
     * Sets a collection of Provider objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $providers A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setProviders(Collection $providers, ?ConnectionInterface $con = null)
    {
        /** @var Provider[] $providersToDelete */
        $providersToDelete = $this->getProviders(new Criteria(), $con)->diff($providers);


        $this->providersScheduledForDeletion = $providersToDelete;

        foreach ($providersToDelete as $providerRemoved) {
            $providerRemoved->setCurrency(null);
        }

        $this->collProviders = null;
        foreach ($providers as $provider) {
            $this->addProvider($provider);
        }

        $this->collProviders = $providers;
        $this->collProvidersPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseProvider objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BaseProvider objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countProviders(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collProvidersPartial && !$this->isNew();
        if (null === $this->collProviders || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collProviders) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getProviders());
            }

            $query = ProviderQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByCurrency($this)
                ->count($con);
        }

        return count($this->collProviders);
    }

    /**
     * Method called to associate a Provider object to this object
     * through the Provider foreign key attribute.
     *
     * @param Provider $l Provider
     * @return $this The current object (for fluent API support)
     */
    public function addProvider(Provider $l)
    {
        if ($this->collProviders === null) {
            $this->initProviders();
            $this->collProvidersPartial = true;
        }

        if (!$this->collProviders->contains($l)) {
            $this->doAddProvider($l);

            if ($this->providersScheduledForDeletion and $this->providersScheduledForDeletion->contains($l)) {
                $this->providersScheduledForDeletion->remove($this->providersScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param Provider $provider The Provider object to add.
     */
    protected function doAddProvider(Provider $provider): void
    {
        $this->collProviders[]= $provider;
        $provider->setCurrency($this);
    }

    /**
     * @param Provider $provider The Provider object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removeProvider(Provider $provider)
    {
        if ($this->getProviders()->contains($provider)) {
            $pos = $this->collProviders->search($provider);
            $this->collProviders->remove($pos);
            if (null === $this->providersScheduledForDeletion) {
                $this->providersScheduledForDeletion = clone $this->collProviders;
                $this->providersScheduledForDeletion->clear();
            }
            $this->providersScheduledForDeletion[]= clone $provider;
            $provider->setCurrency(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Currency is new, it will return
     * an empty collection; or if this Currency has previously
     * been saved, it will retrieve related Providers from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Currency.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|Provider[] List of Provider objects
     * @phpstan-return ObjectCollection&\Traversable<Provider}> List of Provider objects
     */
    public function getProvidersJoinContractor(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = ProviderQuery::create(null, $criteria);
        $query->joinWith('Contractor', $joinBehavior);

        return $this->getProviders($query, $con);
    }

    /**
     * Clears the current object, sets all attributes to their default values and removes
     * outgoing references as well as back-references (from other objects to this one. Results probably in a database
     * change of those foreign objects when you call `save` there).
     *
     * @return $this
     */
    public function clear()
    {
        $this->id = null;
        $this->name = null;
        $this->native = null;
        $this->position = null;
        $this->html_sign = null;
        $this->round_price = null;
        $this->displayed = null;
        $this->iso = null;
        $this->rbk_sync = null;
        $this->round_mode = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);

        return $this;
    }

    /**
     * Resets all references and back-references to other model objects or collections of model objects.
     *
     * This method is used to reset all php object references (not the actual reference in the database).
     * Necessary for object serialisation.
     *
     * @param bool $deep Whether to also clear the references on all referrer objects.
     * @return $this
     */
    public function clearAllReferences(bool $deep = false)
    {
        if ($deep) {
            if ($this->collOrderItems) {
                foreach ($this->collOrderItems as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collPricelistSheets) {
                foreach ($this->collPricelistSheets as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collProviders) {
                foreach ($this->collProviders as $o) {
                    $o->clearAllReferences($deep);
                }
            }
        } // if ($deep)

        $this->collOrderItems = null;
        $this->collPricelistSheets = null;
        $this->collProviders = null;
        return $this;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(CurrencyTableMap::DEFAULT_STRING_FORMAT);
    }

    // archivable behavior

    /**
     * Get an archived version of the current object.
     *
     * @param ConnectionInterface|null $con Optional connection object
     *
     * @return ChildShopCurrenciesArchive An archive object, or null if the current object was never archived
     */
    public function getArchive(?ConnectionInterface $con = null)
    {
        if ($this->isNew()) {
            return null;
        }
        $archive = ChildShopCurrenciesArchiveQuery::create()
            ->filterByPrimaryKey($this->getPrimaryKey())
            ->findOne($con);

        return $archive;
    }
    /**
     * Copy the data of the current object into a $archiveTablePhpName archive object.
     * The archived object is then saved.
     * If the current object has already been archived, the archived object
     * is updated and not duplicated.
     *
     * @param ConnectionInterface|null $con Optional connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException If the object is new
     *
     * @return ChildShopCurrenciesArchive The archive object based on this object
     */
    public function archive(?ConnectionInterface $con = null)
    {
        if ($this->isNew()) {
            throw new PropelException('New objects cannot be archived. You must save the current object before calling archive().');
        }
        $archive = $this->getArchive($con);
        if (!$archive) {
            $archive = new ChildShopCurrenciesArchive();
            $archive->setPrimaryKey($this->getPrimaryKey());
        }
        $this->copyInto($archive, $deepCopy = false, $makeNew = false);
        $archive->setArchivedAt(time());
        $archive->save($con);

        return $archive;
    }

    /**
     * Revert the the current object to the state it had when it was last archived.
     * The object must be saved afterwards if the changes must persist.
     *
     * @param ConnectionInterface|null $con Optional connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException If the object has no corresponding archive.
     *
     * @return $this The current object (for fluent API support)
     */
    public function restoreFromArchive(?ConnectionInterface $con = null)
    {
        $archive = $this->getArchive($con);
        if (!$archive) {
            throw new PropelException('The current object has never been archived and cannot be restored');
        }
        $this->populateFromArchive($archive);

        return $this;
    }

    /**
     * Populates the the current object based on a $archiveTablePhpName archive object.
     *
     * @param ChildShopCurrenciesArchive $archive An archived object based on the same class
      * @param bool $populateAutoIncrementPrimaryKeys
     *               If true, autoincrement columns are copied from the archive object.
     *               If false, autoincrement columns are left intact.
      *
     * @return ChildCurrency The current object (for fluent API support)
     */
    public function populateFromArchive($archive, bool $populateAutoIncrementPrimaryKeys = false)
    {
        if ($populateAutoIncrementPrimaryKeys) {
            $this->setId($archive->getId());
        }
        $this->setName($archive->getName());
        $this->setNative($archive->getNative());
        $this->setPosition($archive->getPosition());
        $this->setHtmlSign($archive->getHtmlSign());
        $this->setRoundPrice($archive->getRoundPrice());
        $this->setDisplayed($archive->getDisplayed());
        $this->setIso($archive->getIso());
        $this->setRbkSync($archive->getRbkSync());
        $this->setRoundMode($archive->getRoundMode());

        return $this;
    }

    /**
     * Removes the object from the database without archiving it.
     *
     * @param ConnectionInterface|null $con Optional connection object
     *
     * @return $this|ChildCurrency The current object (for fluent API support)
     */
    public function deleteWithoutArchive(?ConnectionInterface $con = null)
    {
        $this->archiveOnDelete = false;

        return $this->delete($con);
    }

    /**
     * Code to be run before persisting the object
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preSave(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postSave(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before inserting to database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preInsert(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postInsert(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before updating the object in database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preUpdate(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postUpdate(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before deleting the object in database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preDelete(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postDelete(?ConnectionInterface $con = null): void
    {
            }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);
            $inputData = $params[0];
            $keyType = $params[1] ?? TableMap::TYPE_PHPNAME;

            return $this->importFrom($format, $inputData, $keyType);
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = $params[0] ?? true;
            $keyType = $params[1] ?? TableMap::TYPE_PHPNAME;

            return $this->exportTo($format, $includeLazyLoadColumns, $keyType);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
